glibmm 2.4: Glib::Markup::ParseContext Class Reference

Main Page Widgets glibmm Namespaces Book

# Glib::Markup::ParseContext Class Reference
[Simple XML Subset Parser]

A parse context is used to parse marked-up documents. More...

Inheritance diagram for Glib::Markup::ParseContext:

[legend]
List of all members.

## Public Member Functions
| ParseContext (Parser& parser, ParseFlags flags=ParseFlags(0))
| Creates a new parse context.
virtual | ~ParseContext ()
void | parse (const Glib::ustring& text)
| Feed some data to the ParseContext.
void | parse (const char* text_begin, const char* text_end)
| Feed some data to the ParseContext.
void | end_parse ()
| Signals to the ParseContext that all data has been fed into the parse context with parse().
Glib::ustring | get_element () const
| Retrieves the name of the currently open element.
int | get_line_number () const
| Retrieves the current line number.
int | get_char_number () const
| Retrieves the number of the current character on the current line.
Parser* | get_parser ()
const Parser* | get_parser () const

## Detailed Description

A parse context is used to parse marked-up documents.

You can feed any number of documents into a context, as long as no errors occur; once an error occurs, the parse context can't continue to parse text (you have to destroy it and create a new parse context).

## Constructor & Destructor Documentation

Glib::Markup::ParseContext::ParseContext | ( | Parser& | parser,
|  | ParseFlags | flags = `ParseFlags(0)` |
| ) |  |  | `[explicit]`

Creates a new parse context.

Parameters:

  | parser | A Markup::Parser instance.
  | flags | Bitwise combination of Markup::ParseFlags.

virtual Glib::Markup::ParseContext::~ParseContext | ( |  | ) | `[virtual]`

## Member Function Documentation

void Glib::Markup::ParseContext::parse | ( | const Glib::ustring& | text | ) |

Feed some data to the ParseContext.

The data need not be valid UTF-8; an error will be signalled if it's invalid. The data need not be an entire document; you can feed a document into the parser incrementally, via multiple calls to this function. Typically, as you receive data from a network connection or file, you feed each received chunk of data into this function, aborting the process if an error occurs. Once an error is reported, no further data may be fed to the ParseContext; all errors are fatal.

Parameters:

  | text | Chunk of text to parse.

Exceptions:

  | Glib::MarkupError |

void Glib::Markup::ParseContext::parse | ( | const char * | text_begin,
|  | const char * | text_end |
| ) |  |  |

Feed some data to the ParseContext.

The data need not be valid UTF-8; an error will be signalled if it's invalid. The data need not be an entire document; you can feed a document into the parser incrementally, via multiple calls to this function. Typically, as you receive data from a network connection or file, you feed each received chunk of data into this function, aborting the process if an error occurs. Once an error is reported, no further data may be fed to the ParseContext; all errors are fatal.

Parameters:

  | text_begin | Begin of chunk of text to parse.
  | text_end | End of chunk of text to parse.

Exceptions:

  | Glib::MarkupError |

void Glib::Markup::ParseContext::end_parse | ( |  | ) |

Signals to the ParseContext that all data has been fed into the parse context with parse().

This method reports an error if the document isn't complete, for example if elements are still open.

Exceptions:

  | Glib::MarkupError |

Glib::ustring Glib::Markup::ParseContext::get_element | ( |  | ) | const

Retrieves the name of the currently open element.

Returns:
  The name of the currently open element, or `""`.

int Glib::Markup::ParseContext::get_line_number | ( |  | ) | const

Retrieves the current line number.

Intended for use in error messages; there are no strict semantics for what constitutes the "current" line number other than "the best number we could come up with for error messages."

int Glib::Markup::ParseContext::get_char_number | ( |  | ) | const

Retrieves the number of the current character on the current line.

Intended for use in error messages; there are no strict semantics for what constitutes the "current" character number other than "the best number we could come up with for error messages."

Parser* Glib::Markup::ParseContext::get_parser | ( |  | ) | `[inline]`

const Parser* Glib::Markup::ParseContext::get_parser | ( |  | ) | const`[inline]`

The documentation for this class was generated from the following file:

- markup.h